<?php 
/**
 * $ModDesc
 * 
 * @version   $Id: $file.php $Revision
 * @package   modules
 * @subpackage  $Subpackage.
 * @copyright Copyright (C) November 2010 LandOfCoder.com <@emai:landofcoder@gmail.com>.All rights reserved.
 * @license   GNU General Public License version 2
 */
 
// no direct access
defined('_JEXEC') or die;
require_once JPATH_SITE.'/components/com_content/helpers/route.php';
JModel::addIncludePath(JPATH_SITE.'/components/com_content/models');
require_once JPATH_SITE.DS.'components'.DS.'com_content'.DS.'helpers'.DS.'route.php';
if( !defined('PhpThumbFactoryLoaded') ) {
	require_once dirname(__FILE__).DS.'libs'.DS.'phpthumb/ThumbLib.inc.php';
	define('PhpThumbFactoryLoaded',1);
}
/**
 * modK2SlideshowHelper Class 
 */
abstract class modK2SlideshowHelper {
	
  /**
   * get list of articles follow conditions user selected
   */ 
  public static function getList(&$params)
  {
    $formatter           = $params->get( 'style_displaying', 'title' );
    $titleMaxChars       = $params->get( 'title_max_chars', '100' );
    $descriptionMaxChars = $params->get( 'description_max_chars', 100 );
    $thumbWidth    = (int)$params->get( 'thumbnail_width', 60 );
    $thumbHeight   = (int)$params->get( 'thumbnail_height', 60 );
    $imageHeight   = (int)$params->get( 'main_height', 300 ) ;
    $imageWidth    = (int)$params->get( 'main_width', 650 ) ;
    $isThumb       = $params->get( 'auto_renderthumb',1);
	$limit 	       = $params->get( 'limit_items',  5 );
    $ordering      = str_replace("-", " ", $params->get('k2_ordering', 'created-asc') ); 
    $replacer      = $params->get('replacer','...'); 
    $limitDescriptionBy = $params->get('limit_description_by','char');
	$isAutoStripsTag = $params->get('auto_strip_tags','1');
    // Get the dbo
    $db = JFactory::getDbo();
	$condition     = self::buildConditionQuery( $params );
	
	$tags = $params->get("k2_tags", array() );
	
	//
	$my 	       = &JFactory::getUser();
	$overrideLinks = array();
	if( $tmp = $params->get('override_links', '' ) ){
			$tmp = is_array($tmp)?$tmp:array($tmp);
			foreach( $tmp as $titem ){
				$link  = explode("@", $titem );	
				if( count($link) > 1 ){
					$overrideLinks[(int)trim(strtolower($link[0]))]=$link[1];
				}
			}
		}
		$jnow = &JFactory::getDate();
		$now = $jnow->toMySQL();
		$nullDate = $db->getNullDate();
  	    // Get an instance of the generic articles model
  	    $query = "SELECT a.*, cr.rating_sum/cr.rating_count as rating, c.name as category_title,
							c.id as categoryid, c.alias as category_alias, c.params as categoryparams, cc.commentcount as commentcount".
					" FROM #__k2_items as a".
						" LEFT JOIN #__k2_categories c ON c.id = a.catid" .
						" LEFT JOIN #__k2_rating as cr ON a.id = cr.itemid".
						" LEFT JOIN (select cm.itemid  as id, count(cm.id) as commentcount from #__k2_comments as cm
																	where cm.published=1 group by cm.itemid) as cc on a.id = cc.id";
			
			
			if ( $params->get("k2_source") == 'k2_tags' && !empty($tags) ) {
						$query .= " LEFT JOIN #__k2_tags_xref tags_xref ON tags_xref.itemID = a.id LEFT JOIN #__k2_tags tags ON tags.id = tags_xref.tagID ";


  			}
			$query .= " WHERE a.published = 1"
						. " AND a.access IN (".implode(',', $my->authorisedLevels()).")"
						. " AND a.trash = 0"
					;	
			if( $params->get('featured_items_show','0') == 0 ){
				$query.= " AND a.featured != 1";
			} elseif(  $params->get('featured_items_show','0') == 2 ) {
				$query.= " AND a.featured = 1";
			}
			$query .= " AND c.trash = 0 
				AND ( a.publish_up = ".$db->Quote($nullDate)." OR a.publish_up <= ".$db->Quote($now)." ) 
				AND ( a.publish_down = ".$db->Quote($nullDate)." OR a.publish_down >= ".$db->Quote($now)." ) 
			";
			
			if ( $params->get("k2_source") == 'k2_tags' && !empty($tags) ) {
				$query .= " AND tags_xref.tagID IN('".implode("','", $tags)."')";
				$condition = "";
			}
			$query .=  $condition . ' ORDER BY ' . $ordering;	
			$query .=  $limit ? ' LIMIT ' . $limit : '';
			
			$db->setQuery($query);
			$items = $db->loadObjectlist();
 			if( !is_array($items) ){	$items = array();		}
    foreach ($items as &$item) {
      $item->slug = $item->id.':'.$item->alias;
      $item->catslug = $item->catid.':'.$item->category_alias;
 		$item->categoryLink = urldecode(JRoute::_(K2HelperRoute::getCategoryRoute($item->catid.':'.urlencode($item->category_alias))));
        // We know that user has the privilege to view the article
        $item->link = JRoute::_(K2HelperRoute::getItemRoute($item->slug, $item->catslug));
    

      $item->date = JHtml::_('date', $item->created, JText::_('DATE_FORMAT_LC2')); 
    	
    	if( array_key_exists($item->id,$overrideLinks) ){
				$item->link=$overrideLinks[$item->id];
		}
			
      $item = self::parseImages( $item );

      if( $item->mainImage &&  $image=self::renderThumb($item->mainImage, $imageWidth, $imageHeight, $item->title, $isThumb ) ){
        $item->mainImage = $image;
      }
      if( $item->thumbnail &&  $image = self::renderThumb($item->thumbnail, $thumbWidth, $thumbHeight, $item->title ,  $isThumb ) ){
        $item->thumbnail = $image;
      }
      $item->fulltext = $item->introtext;
      $item->introtext   = JHtml::_('content.prepare', $item->introtext);
      $item->subtitle    = self::substring( $item->title, $titleMaxChars, $replacer, $isAutoStripsTag  );
     
      if( $limitDescriptionBy=='word' ){
        $string        = preg_replace( "/\s+/", " ", strip_tags($item->introtext) );
        $tmp         = explode(" ", $string);
        $item->description = $descriptionMaxChars>count($tmp)?$string:implode(" ",array_slice($tmp, 0, $descriptionMaxChars)).$replacer;
      } else {
        $item->description = self::substring( $item->introtext, $descriptionMaxChars, $replacer , $isAutoStripsTag );
      }
      
        
    }
	
    return $items;
  }
	/**
	 * build condition query base parameter  
	 * 
	 * @param JParameter $params;
	 * @return string.
	 */
	public  static function buildConditionQuery( $params ){
		$source = trim($params->get( 'k2_source', 'k2_category' ) );
		if( $source == 'k2_category' ){
			$catids = $params->get( 'k2_category','');
			
			if( !$catids ){
				return '';
			}
			$catids = !is_array($catids) ? $catids : '"'.implode('","',$catids).'"';
			$condition = ' AND  a.catid IN( '.$catids.' )';
		} else {
			$ids = preg_split('/,/',$params->get( 'k2_items_ids',''));	
			$tmp = array();
			foreach( $ids as $id ){
				$tmp[] = (int) trim($id);
			}
			$condition = " AND a.id IN('". implode( "','", $tmp ) ."')";
		}
		return $condition;
	}	
	/**
	 * parser a custom tag in the content of article to get the image setting.
	 * 
	 * @param string $text
	 * @return array if maching.
	 */
	public static function parserCustomTag( $text ){ 
		if( preg_match("#{lofimg(.*)}#s", $text, $matches, PREG_OFFSET_CAPTURE) ){ 
			return $matches;
		}	
		return null;
	}
	
	/**
	 *  check the folder is existed, if not make a directory and set permission is 755
	 *
	 *
	 * @param array $path
	 * @access public,
	 * @return boolean.
	 */
	public static function makeDir( $path ){
		$folders = explode ( '/',  ( $path ) );
		$tmppath =  JPATH_SITE.DS.'images'.DS.'lofthumbs'.DS;
		if( !file_exists($tmppath) ) {
			JFolder::create( $tmppath, 0755 );
		}; 
		for( $i = 0; $i < count ( $folders ) - 1; $i ++) {
			if (! file_exists ( $tmppath . $folders [$i] ) && ! JFolder::create( $tmppath . $folders [$i], 0755) ) {
				return false;
			}	
			$tmppath = $tmppath . $folders [$i] . DS;
		}		
		return true;
	}
	
	/**
	 *  check the folder is existed, if not make a directory and set permission is 755
	 *
	 * @param array $path
	 * @access public,
	 * @return boolean.
	 */
	public static function renderThumb( $path, $width=100, $height=100, $title='', $isThumb=true ){
		
		if( $isThumb ){
			$path = str_replace( JURI::base(), '', $path );
			$imagSource = JPATH_SITE.DS. str_replace( '/', DS,  $path );
			if( file_exists($imagSource)  ) {
				$path =  $width."x".$height.'/'.$path;
				$thumbPath = JPATH_SITE.DS.'images'.DS.'lofthumbs'.DS. str_replace( '/', DS,  $path );
				if( !file_exists($thumbPath) ) {
					$thumb = PhpThumbFactory::create( $imagSource  );  
					if( !self::makeDir( $path ) ) {
							return '';
					}		
					$thumb->adaptiveResize( $width, $height);
					 
					$thumb->save( $thumbPath  ); 
				}
				$path = JURI::base().'images/lofthumbs/'.$path;
			} 
		}
		return '<img src="'.$path.'" title="'.$title.'" >';
	}
	
	/**
	 * get parameters from configuration string.
	 *
	 * @param string $string;
	 * @return array.
	 */
	public static function parseParams( $string ) {
		$string = html_entity_decode($string, ENT_QUOTES);
		$regex = "/\s*([^=\s]+)\s*=\s*('([^']*)'|\"([^\"]*)\"|([^\s]*))/";
		 $params = null;
		 if(preg_match_all($regex, $string, $matches) ){
				for ($i=0;$i<count($matches[1]);$i++){ 
				  $key 	 = $matches[1][$i];
				  $value = $matches[3][$i]?$matches[3][$i]:($matches[4][$i]?$matches[4][$i]:$matches[5][$i]);
				  $params[$key] = $value;
				}
		  }
		  return $params;
	}
	
	/**
	 * looking for image inside the media folder.
	 */
	public static function lookingForK2Image( &$item, $size='XL' ){
		//Image
		$item->imageK2Image='';
		if (JFile::exists(JPATH_SITE.DS.'media'.DS.'k2'.DS.'items'.DS.'cache'.DS.md5("Image".$item->id).'_'.$size.'.jpg'))
			$item->imageK2Image = JURI::root().'media/k2/items/cache/'.md5("Image".$item->id).'_'.$size.'.jpg';
		return $item; 
	}
	
	/**
	 * parser a image in the content of article.
	 *
	 * @param.
	 * @return
	 */
	public static function parseImages(  $row ){
		$text =  $row->introtext;
		$data = self::parserCustomTag( $text );
		if( isset($data[1][0]) ){
			$tmp = self::parseParams( $data[1][0] );
			$row->mainImage = isset($tmp['src']) ? $tmp['src']:'';
			$row->thumbnail = $row->mainImage ;// isset($tmp['thumb']) ?$tmp['thumb']:'';	
		} else {
			$row  = self::lookingForK2Image(  $row );
			
			if( $row->imageK2Image != '' ){
				$row->thumbnail = $row->mainImage = $row->imageK2Image;	
				return $row;
			}
			
			$regex = "/\<img.+src\s*=\s*\"([^\"]*)\"[^\>]*\>/";
			preg_match ($regex, $text, $matches); 
			$images = (count($matches)) ? $matches : array();
			if (count($images)){
				$row->introtext = str_replace($images[0],"",$row->introtext);
				$row->mainImage = $images[1];
				$row->thumbnail = $images[1];
			} else {
				$row->thumbnail = '';
				$row->mainImage = '';	
			}
		}
	}
	
	/**
	 * load css - javascript file.
	 * 
	 * @param JParameter $params;
	 * @param JModule $module
	 * @return void.
	 */
	public static function loadMediaFiles( $params, $module ){
		$mainframe = JFactory::getApplication();
		$template = $mainframe->getTemplate();
		
		$document = &JFactory::getDocument();
		$document->addScript( JURI::root(true). '/modules/'.$module->module.'/assets/jscript.js' ); 	
		if(file_exists(JPATH_BASE.DS.'templates/'.$template.'/css/'.$module->module.'.css')){
			 $document->addStyleSheet(  JURI::root(true).'/templates/'.$template.'/css/'.$module->module.'.css' );		
		} else {
			$document->addStyleSheet( JURI::root(true). '/modules/'.$module->module.'/assets/jstyle.css' );	
		}
	}
	
	/**
	 * get a subtring with the max length setting.
	 * 
	 * @param string $text;
	 * @param int $length limit characters showing;
	 * @param string $replacer;
	 * @return tring;
	 */
	public static function substring( $text, $length = 100, $replacer='...', $isAutoStripsTag = true ){
		$string =  $isAutoStripsTag?  strip_tags( $text ):$text;
		return JString::strlen( $string ) > $length ? JString::substr( $string, 0, $length ).$replacer: $string;
	}
}
?>